Ofcas.Lk.Api.Client - Version 3.0 3.0.0.113

Public Member Functions | Public Attributes | Protected Member Functions | List of all members
Ofcas.Lk.Api.Client.Ui.ProjectUi Class Reference

ProjectUi is the representation of a LogiKal project and provides methods with user interactions. The children are of type PhaseUi. The children can be received from the InfoList (CoreObject<T>.Infos). More...

Inheritance diagram for Ofcas.Lk.Api.Client.Ui.ProjectUi:

## Public Member Functions
new PhaseUi | GetChild (PhaseInfo phaseInfo)
| Gets a PhaseUi based on a PhaseInfo. More...
new ProjectInformationContainerUi | GetProjectInformationContainer (IProjectInformationType projectInformationType)
| Returns the project information container to the given project information type (IProjectInformationType). The ProjectInformationContainerUi allows access to the items of the corresponding project information. More...
new PhaseUi | GetPhase (PhaseInfo phaseInfo)
| This method is deprecated. Please use GetChild(PhaseInfo) instead. More...
new IEnumerable< PhaseUi > | GetChildren (IEnumerable< PhaseInfo > childrenInfos=null)
| Gets a PhaseUis based on a PhaseInfos. More...
void | SetApplicationHandle (IntPtr uiHandle)
| Sets an ui handle. All opened user interfaces used this handle as parent. After an operation the default handle from the login scope will be used (ServiceProxyBase<TService,TCoreObject>.Login(string,long,System.TimeSpan)). More...
void | Report (ReportItem reportItem, IEnumerable< ICoreInfoReportable > items, Dictionary< string, string > parameters)
| This method is deprecated. Please use Report(ReportItem, IEnumerable<ICoreInfoReportable>, Dictionary<string, object>) instead. More...
IDialogResult< ReportResult > | Report (ReportItem reportItem, IEnumerable< ICoreInfoReportable > reportables, Dictionary< string, object > parameters)
| Creates a report according to the given report type via user interface. The report is generated for the passed elevations. If an empty list is passed, a report with all elevations of the project is automatically generated. More...
virtual IList< ProjectRunnableProgram > | GetRunnablePrograms ()
| Retrieves a list of available ProjectRunnablePrograms. More...
OperationStatus | RunProgram (ProjectRunnableProgram program, Dictionary< string, object > optionalParameters=null)
| This method is deprecated. Please use ShowModal(ProjectRunnableProgram, Dictionary<string, object>) instead. More...
DialogResultCode | ShowModal (ProjectRunnableProgram program, Dictionary< string, object > parameters)
| Shows the ProjectRunnableProgram in a modal window. More...
ISynchronizedOperation | Show (ProjectRunnableProgram program, Dictionary< string, object > parameters)
| Shows the ProjectRunnableProgram in a modal window. More...
DialogResultCode | WaitForShow (ISynchronizedOperation synchronizedOperation)
| Waits for the ISynchronizedOperation to finish. More...
IDialogResult< ExportResult > | ExportCncFiles (IEnumerable< ElevationInfo > elevationInfos)
| Opens a user interface to export the given elevations as CNC files. More...
IDialogResult< Stream > | SelectGlass ()
| Selects a glass via user interface. More...
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.Project
IList< IProjectInformationType > | GetProjectInformations ()
| Returns all available project informations for the current Project. More...
ProjectInformationContainer | GetProjectInformationContainer (IProjectInformationType projectInformationType)
| Returns the project information container to the given project information type (IProjectInformationType). The ProjectInformationContainer allows access to the items of the corresponding project information. More...
override Phase | GetChild (PhaseInfo phaseInfo)
| Gets a Phase based on a PhaseInfo. More...
override IList< Phase > | GetChildren (IEnumerable< PhaseInfo > childrenInfos=null)
| Gets Phases based on the list of PhaseInfos. More...
Phase | GetPhase (PhaseInfo phaseInfo)
| This method is deprecated. Please use GetChild(PhaseInfo) instead. More...
override OperationInfo | CanEdit (string key, object value)
| Checks whether a project can be edited or not. More...
override ProjectInfo | Edit (string key, object value)
| Edits a project based on a key and a value. More...
PhaseInfo | CreatePhase (string name, string description)
| This method is obsolete, please use CanCreateChild() and CreateChild() instead and change the name with Edit(). See WellKnownEditKeys.Phase. More...
override OperationInfo | CanCreateChild ()
| Checks whether a phase can be created or not. More...
override PhaseInfo | CreateChild ()
| Creates a new phase with a default name. Call Phase.Edit with WellKnownEditKeys.Phase to change values. More...
IList< ReportCategory > | GetAvailableUserReports ()
| This method is deprecated. Please use GetReports instead. More...
IList< ReportCategory > | GetReports ()
| Return all available reports. More...
override PhaseInfo | RefreshChild (PhaseInfo childInfo)
OperationInfo | CanAdd (ICoreInfo coreInfo)
| Used to check if an ElevationInfo can be added to a project of type ProjectType.FabricationLot. More...
PhaseInfo | Add (ICoreInfo coreInfo)
| Used to add an ElevationInfo to a project of type ProjectType.FabricationLot. More...
override OperationInfo | CanDeleteChild (PhaseInfo childInfo)
override void | DeleteChild (PhaseInfo childInfo, bool forceDelete=false)
void | UpdatePartsLists (IEnumerable< ElevationInfo > items)
| Update the parts list for all given elevations. If an empty list is passed, an update with all elevations of the project is automatically done. More...
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
TOwnInfo | Refresh ()
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObject
bool | CanDispose ()
| Checks whether the ICoreInfo can be disposed. More...

## Public Attributes
new ProjectCenterUi | Parent => (ProjectCenterUi) base.Parent
| The parent of this object. More...
Public Attributes inherited from Ofcas.Lk.Api.Client.Core.Project
DocumentContainer | Documents => _documentContainerLifetimeManager.GetCoreObject()

## Protected Member Functions
override Phase | CreateNewInstance (Guid coreObjectId, PhaseInfo phaseInfo)
override ProjectInformationContainer | CreateNewInstance (Guid coreObjectId)
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.Project
override IEnumerable< PhaseInfo > | GetChildrenInfos ()
override void | Dispose (bool disposing)
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
| CoreObjectFullyQualified (IServiceFactory< IApiService > serviceFactory, Guid coreObjectId, TParent parent, TOwnInfo ownInfo)
| Creates a new instance of CoreObjectFullyQualified<TParent,TOwnInfo,TChild,TChildInfo> with the given parameters. More...

## Additional Inherited Members
Properties inherited from Ofcas.Lk.Api.Client.Core.Project
ISynchronizationContainer | SynchronizationContainer`[get]`
Properties inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
TParent | Parent`[get]`
TOwnInfo | Info`[get]`
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObjectWithDocuments
DocumentContainer | Documents`[get]`
| The DocumentContainer of the ICoreObject. More...
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObjectWithSynchronizations
ISynchronizationContainer | SynchronizationContainer`[get]`
| The ISynchronizationContainer of this ICoreObject. More...
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObject
Guid | CoreObjectId`[get]`
| This property is deprecated. Please use ICoreObject.Id instead. More...
Guid | Id`[get]`
| The unique identifier of this core object. More...

## Detailed Description

ProjectUi is the representation of a LogiKal project and provides methods with user interactions. The children are of type PhaseUi. The children can be received from the InfoList (CoreObject<T>.Infos).

## Member Function Documentation

## ◆ ExportCncFiles()

IDialogResult<ExportResult> Ofcas.Lk.Api.Client.Ui.ProjectUi.ExportCncFiles | ( | IEnumerable< ElevationInfo > | elevationInfos | ) |

Opens a user interface to export the given elevations as CNC files.

Parameters

  elevationInfos | The list of elevations to be exported.

Returns
  Returns a IDialogResult for the export.

Exceptions

  ApiException | Occurs if the method fails.

## ◆ GetChild()

new PhaseUi Ofcas.Lk.Api.Client.Ui.ProjectUi.GetChild | ( | PhaseInfo | phaseInfo | ) |

Gets a PhaseUi based on a PhaseInfo.

Parameters

  phaseInfo | The PhaseInfo of the PhaseUi to be returned.

Returns
  Returns a PhaseUi based on the given PhaseInfo.

## ◆ GetChildren()

new IEnumerable<PhaseUi> Ofcas.Lk.Api.Client.Ui.ProjectUi.GetChildren | ( | IEnumerable< PhaseInfo > | childrenInfos = `null` | ) |

Gets a PhaseUis based on a PhaseInfos.

Parameters

  childrenInfos | The PhaseInfos of the PhaseUis to be returned. If an empty list is given all PhaseUis of this ProjectUi will be returned.

Returns
  Returns a list of PhaseUi based on the given PhaseInfos.

Exceptions

  ArgumentNullException | Thrown if list of PhaseInfos is null.

## ◆ GetPhase()

new PhaseUi Ofcas.Lk.Api.Client.Ui.ProjectUi.GetPhase | ( | PhaseInfo | phaseInfo | ) |

This method is deprecated. Please use GetChild(PhaseInfo) instead.

## ◆ GetProjectInformationContainer()

new ProjectInformationContainerUi Ofcas.Lk.Api.Client.Ui.ProjectUi.GetProjectInformationContainer | ( | IProjectInformationType | projectInformationType | ) |

Returns the project information container to the given project information type (IProjectInformationType). The ProjectInformationContainerUi allows access to the items of the corresponding project information.

Parameters

  projectInformationType | The type for the project information to get.

Returns
  The ProjectInformationContainerUi object. The lifetime of this object must be administrated outside and can only be used, if the ProjectUi instance exists.

## ◆ GetRunnablePrograms()

virtual IList<ProjectRunnableProgram> Ofcas.Lk.Api.Client.Ui.ProjectUi.GetRunnablePrograms | ( |  | ) |
| virtual

Retrieves a list of available ProjectRunnablePrograms.

Returns
  Returns a list of available ProjectRunnablePrograms.

## ◆ Report() [1/2]

void Ofcas.Lk.Api.Client.Ui.ProjectUi.Report | ( | ReportItem | reportItem,
|  | IEnumerable< ICoreInfoReportable > | items,
|  | Dictionary< string, string > | parameters
| ) |  |

This method is deprecated. Please use Report(ReportItem, IEnumerable<ICoreInfoReportable>, Dictionary<string, object>) instead.

Parameters

  reportItem |
  items |
  parameters |

## ◆ Report() [2/2]

IDialogResult<ReportResult> Ofcas.Lk.Api.Client.Ui.ProjectUi.Report | ( | ReportItem | reportItem,
|  | IEnumerable< ICoreInfoReportable > | reportables,
|  | Dictionary< string, object > | parameters
| ) |  |

Creates a report according to the given report type via user interface. The report is generated for the passed elevations. If an empty list is passed, a report with all elevations of the project is automatically generated.

Parameters

  reportItem | Defines the type of report. Report types can be received with Project.GetReports
  reportables | List of reportables to be used for the report
  parameters | A dictionary with parameters can be used to specify reports options. (Not supported)

Returns
  Returns a IDialogResult for the given report item.

## ◆ RunProgram()

OperationStatus Ofcas.Lk.Api.Client.Ui.ProjectUi.RunProgram | ( | ProjectRunnableProgram | program,
|  | Dictionary< string, object > | optionalParameters = `null`
| ) |  |

This method is deprecated. Please use ShowModal(ProjectRunnableProgram, Dictionary<string, object>) instead.

## ◆ SelectGlass()

IDialogResult<Stream> Ofcas.Lk.Api.Client.Ui.ProjectUi.SelectGlass | ( |  | ) |

Selects a glass via user interface.

Returns
  Returns a dialog result with a stream for the selected glass.

## ◆ SetApplicationHandle()

void Ofcas.Lk.Api.Client.Ui.ProjectUi.SetApplicationHandle | ( | IntPtr | uiHandle | ) |

Sets an ui handle. All opened user interfaces used this handle as parent. After an operation the default handle from the login scope will be used (ServiceProxyBase<TService,TCoreObject>.Login(string,long,System.TimeSpan)).

Parameters

  uiHandle | the ui handle to be used for opened user interfaces from this class.

## ◆ Show()

ISynchronizedOperation Ofcas.Lk.Api.Client.Ui.ProjectUi.Show | ( | ProjectRunnableProgram | program,
|  | Dictionary< string, object > | parameters
| ) |  |

Shows the ProjectRunnableProgram in a modal window.

Parameters

  program | The ProjectRunnableProgram to be run.
  parameters | The optional parameters for the ProjectRunnableProgram to be run. See WellKnownParameterKeys.Project.Program for the available keys.

Returns
  Returns an ISynchronizedOperation for the ProjectRunnableProgram.

Exceptions

  ApiException | Occurs if the method fails.

## ◆ ShowModal()

DialogResultCode Ofcas.Lk.Api.Client.Ui.ProjectUi.ShowModal | ( | ProjectRunnableProgram | program,
|  | Dictionary< string, object > | parameters
| ) |  |

Shows the ProjectRunnableProgram in a modal window.

Parameters

  program | The ProjectRunnableProgram to be run.
  parameters | The optional parameters for the ProjectRunnableProgram to be run. See WellKnownParameterKeys.Project.Program for the available keys.

Returns
  Returns a DialogResultCode for the ProjectRunnableProgram.

Exceptions

  ApiException | Occurs if the method fails.

## ◆ WaitForShow()

DialogResultCode Ofcas.Lk.Api.Client.Ui.ProjectUi.WaitForShow | ( | ISynchronizedOperation | synchronizedOperation | ) |

Waits for the ISynchronizedOperation to finish.

Parameters

  synchronizedOperation | The ISynchronizedOperation to be finished.

Returns
  Returns a DialogResultCode for the ISynchronizedOperation.

## Member Data Documentation

## ◆ Parent

new ProjectCenterUi Ofcas.Lk.Api.Client.Ui.ProjectUi.Parent => (ProjectCenterUi) base.Parent

The parent of this object.

The documentation for this class was generated from the following file:

- ProjectUi.cs